package com.fp.persistence.pgeneral.menu;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEMENU*/
@Entity(name="TgeneMenu")
@Table(name="TGENEMENU")
public class TgeneMenu extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneMenu
*/
@Id
@Column(name="MENUCODE" ,nullable=false, updatable=false)
private Integer pk;
@Column(name="DESCRIPTION", nullable=true)

/**
* Descripcion default del menu
*/
private String description;

/**Contructor por defecto*/
public TgeneMenu(){
}
/**Contructor de TgeneMenu
@param pPk Clave Primaria del entity
*/
public TgeneMenu(Integer pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneMenu
*/
public static TgeneMenu find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneMenu obj = pEntityManager.find(TgeneMenu.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneMenu
@return El objeto que referencia a la Clave primaria de TgeneMenu
*/
public Integer getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneMenu
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneMenu
*/
public void setPk(Integer pPk){
  pk=pPk;
}
/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneMenu))return false;
    TgeneMenu that = (TgeneMenu) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneMenu
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneMenu
*/
public Object createInstance(){
 TgeneMenu instance=new TgeneMenu();	
 return instance;
}
/**Clona la entidad TgeneMenu
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneMenu p=(TgeneMenu)this.clone();
  return p;
}
}
